<template>
  <div class="row margin-0-mobile px-4 py-2 p-md-0 blueBG-mobile">
    <div class="col padding-0-mobile">
      <div class="input-group flex-column-reverse flex-md-row">
        <mobile-search-button
          :changeQuery="changeQuery"
          :textKey="config.textKeys.mobileSearchButton"
        />
        <search-bar-text-field
          :config="config"
          :changeQuery="changeQuery"
        />
        <search-scope-tabs
          v-if="config.useScopeDropdown"
          :config="config"
        />
        <search-button
          :changeQuery="changeQuery"
        />
        <!-- commented our for Prudction release -->
        <!-- <advanced-search-button v-if="this.advancedSearch"
        /> -->


      </div>
    </div>
  </div>
</template>

<script>
import MobileSearchButton from "@/components/search/search-filters/MobileSearchButton";
import SearchBarTextField from "@/components/search/search-filters/SearchBarTextField";
import SearchScopeTabs from "@/components/search/search-filters/SearchScopeTabs";
import SearchButton from "@/components/search/search-filters/SearchButton";
import AdvancedSearchButton from "./AdvancedSearchButton.vue";

export default {
  name: "SearchBar",
  components: {SearchButton, SearchScopeTabs, SearchBarTextField, MobileSearchButton, AdvancedSearchButton},
  props: {
    config: Object
  },
  data() {
    return {
      advancedSearch: this.$env.content.datasets.advancedSearch
    }
  },
  computed: {
    getQuery() {
      return this.$store.getters[`${this.config.getQuery[0]}/${this.config.getQuery[1]}`];
    }
  },
  methods: {
    setQuery(query) {
      this.$store.dispatch(`${this.config.setQuery[0]}/${this.config.setQuery[1]}`, query);
    },
    changeQuery(query) {
      if ( ! query) query = this.getQuery;
      this.$router
        .replace({
          query: Object.assign({}, this.$route.query, { query }, { page: 1 }),
        })
        .catch((error) => {
          console.error(error);
        });
      this.setQuery(query);
    }
  }
}
</script>

<style lang="scss" scoped>

@media screen and (max-width: 767.5px) {
  .margin-0-mobile {
    margin: 0;
  }

  .blueBG-mobile {
    background-color: #F2F5F9;
    padding: 15px !important;
    margin: 0 -15px 0 -15px !important;
  }

  .padding-0-mobile {
    padding: 0;
  }
}
</style>
